/* This example allows you to easily use TI-BASIC as an extension language.

   Copyright (C) Kevin Kofler, 2004. All rights reserved.

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included
   in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
   DEALINGS IN THE SOFTWARE. */

#include <tigcclib.h>
#include "tibasext.h"

void Dummy(void) {}
void HelloW(void) {DlgMessage("Hi","Hello world",BT_OK,BT_NONE);push_quantum(FALSE_TAG);}

EXTENSIONS
  DEFINE_EXTENSION(0)
  DEFINE_EXTENSION(1)
ENDEXTENSIONS

EXT_ENTRIES
  DEFINE_EXT_ENTRY(Dummy, APP_EXT_PROGRAM)
  DEFINE_EXT_ENTRY(HelloW, APP_EXT_FUNCTION)
ENDEXT_ENTRIES

BASEXTFRAME("HelloW", 2)
  DEFINE_EXT_STRINGS(0, "Dummy", "Does nothing")
  DEFINE_EXT_STRINGS(1, "HelloW", "Displays hello world and returns false")
ENDFRAME

void _main(void)
{
  if (!InstallBasExts()) ER_throw(ER_MEMORY);
  TRY
    progrun("test");
  FINALLY
    UninstallBasExts();
  ENDFINAL
}
